from Blossom import *
import numpy as np

node_to_root = {k:[] for k in range(16)}

def getData(file):
    with open(file) as f:
        firstLine = f.readline()
        firstLine = [x.strip() for x in firstLine.split(',')]
        numOfPatients = int(firstLine[0])
        lines = f.readlines()[numOfPatients:]
        preferences = {k:[] for k in range(numOfPatients)}

        for line in lines:
            x = line.split(",")
            patient = int(x[1])
            donor = int(x[0])

            preferences[patient].append(donor)

        f.close()

    return preferences

def createUndirectedGraph():
    undirectedGraph = {}
    for patient in preferences:
        for donor in preferences[patient]:
            if patient in preferences[donor]:
                if patient not in undirectedGraph:
                    undirectedGraph[patient] = []
                undirectedGraph[patient].append(donor)
    return undirectedGraph

file = "C:\\Users\\molly\\OneDrive\\Documents\\year 3\\FYP\\kidney\\MD-00001-00000025.md"

preferences = getData(file)

G = createUndirectedGraph()
keys = list(G.keys())
values = list(G.values())

vals = []
for c in values:
    for i in c:
        if i not in vals:
            vals.append(i)
vals.sort()

with open('infile.csv', 'w') as f:
    sys.stdout = f
    A = [[0 for i in range(len(G))] for j in range(len(G))]
    for k in keys:
        for v in vals:
            if v in G[k]:
                A[vals.index(v)][keys.index(k)] = 1

    for a in A:
        print(*a, sep=", ")