from Kosaraju import Graph
import sys
import numpy as np

stack = []
allCycles = []
blockedSet = []
blockedMap = {}

def getBSet(v):
    if v not in blockedMap:
        blockedMap[v] = []
    return blockedMap[v]

def unblock(u):
    blockedSet.remove(u)
    if u in blockedMap:
        for v in blockedMap[u]:
            if v in blockedSet:
                unblock(v)
        del blockedMap[u]

def findCycles(sccGraph, startVertex, currV):
    cycleFound = False
    stack.append(currV)
    blockedSet.append(currV)
    cycle = []
    for neighbour in sccGraph[currV]:
        if neighbour == startVertex:
            stack.append(startVertex)
            cycle.append(stack[:])
            cycle.reverse()
            stack.pop()
            #if (len(cycle[0]) <= 10):
            allCycles.append(cycle)
            cycleFound = True
        elif (neighbour not in blockedSet):
            gotCycle = findCycles(sccGraph, startVertex, neighbour)
            cycleFound = cycleFound or gotCycle
    if cycleFound:
        unblock(currV)
    else:
        for patient in sccGraph[currV]:
            bSet = getBSet(patient)
            if currV not in bSet:
                bSet.append(currV)
    stack.pop()
    return cycleFound

def leastIndexSCC(scc, sccGraph):
    minimum = sys.maxsize
    minVertex = None
    minScc = None
    for cycle in scc:
        if len(cycle) == 1:
            continue
        for v in cycle:
            if sccGraph[v]:
                for donor in sccGraph[v]:
                    if donor in cycle:
                        if donor < minimum:
                            minimum = donor
                            minVertex = sccGraph[donor]
                            minScc = cycle
            else:
                return None
        return minimum

def runJohnsonAlgorithm(scc, sccGraph):
    startIndex = 0
    while startIndex <= len(sccGraph):
        maybeLeastVertex = leastIndexSCC(scc, sccGraph)
        if maybeLeastVertex == None:
            break
        startIndex = maybeLeastVertex
        blockedSet = []
        blockedMap = {}
        findCycles(sccGraph, startIndex, startIndex)
        del sccGraph[startIndex]
        for patient in sccGraph:
            if startIndex in sccGraph[patient]:
                sccGraph[patient].remove(startIndex)
        for c in scc:
            if startIndex in c:
                c.remove(startIndex)
        startIndex = startIndex + 1

    return [item for items in allCycles for item in items]
    